/*
 ******************************************************************************
 * Copyright (c) 2017-2018, The Linux Foundation. All rights reserved.
 * Permission to use, copy, modify, and/or distribute this software for
 * any purpose with or without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all copies.
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
 * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * ****************************************************************************
 */

#ifndef __NSS_GRE_REDIR_STATS_H__
#define __NSS_GRE_REDIR_STATS_H__

/*
 * GRE REDIR statistics
 */
enum nss_gre_redir_stats_types {
	NSS_GRE_REDIR_STATS_TX_PKTS,
	NSS_GRE_REDIR_STATS_TX_BYTES,
	NSS_GRE_REDIR_STATS_TX_DROPS,
	NSS_GRE_REDIR_STATS_RX_PKTS,
	NSS_GRE_REDIR_STATS_RX_BYTES,
	NSS_GRE_REDIR_STATS_RX_DROPS,
	NSS_GRE_REDIR_STATS_SJACK_TX_PKTS,
	NSS_GRE_REDIR_STATS_SJACK_RX_PKTS,
	NSS_GRE_REDIR_STATS_OFFLOAD_TX_PKTS,
	NSS_GRE_REDIR_STATS_OFFLOAD_RX_PKTS,
	NSS_GRE_REDIR_STATS_ENCAP_SG_ALLOC_DROP,
	NSS_GRE_REDIR_STATS_DECAP_FAIL_DROP,
	NSS_GRE_REDIR_STATS_DECAP_SPLIT_DROP,
	NSS_GRE_REDIR_STATS_SPLIT_SG_ALLOC_FAIL,
	NSS_GRE_REDIR_STATS_SPLIT_LINEAR_COPY_FAIL,
	NSS_GRE_REDIR_STATS_SPLIT_NOT_ENOUGH_TAILROOM,
	NSS_GRE_REDIR_STATS_MAX
};

/*
 * NSS GRE REDIR statistics APIs
 */
extern struct dentry *nss_gre_redir_stats_dentry_create(void);

#endif /* __NSS_GRE_REDIR_STATS_H__ */
